#include <p18f14k50.h> 
//#include <usart.h>
# include <string.h>
#include <stdio.h>
#include <delays.h>

	#pragma config    CPUDIV = NOCLKDIV
	#pragma config    USBDIV = OFF  
	#pragma config    FOSC = HS
	#pragma config    PLLEN = OFF 
	#pragma config    FCMEN = OFF
	#pragma config    IESO = OFF 
	#pragma config    PWRTEN = ON
	#pragma config    BOREN = ON
	#pragma config    BORV = 30
	#pragma config    WDTEN = OFF
	#pragma config    WDTPS = 1
	#pragma config    MCLRE = ON
	#pragma config    HFOFST = ON 
	#pragma config    STVREN = ON 
	#pragma config    LVP = OFF
	#pragma config    BBSIZ = OFF 
	#pragma config    XINST = OFF
	#pragma config    CP0 = ON 
	#pragma config    CPB = ON 
	#pragma config    CPD = ON 
	#pragma config    WRT1= ON 
	#pragma config    WRTB = ON 
	#pragma config    WRTC = ON 
	#pragma config    WRTD = ON 
	#pragma config    EBTRB = ON
	
// Slave mode

  #define SCL TRISBbits.TRISB6 // SCL line
  #define SDA TRISBbits.TRISB4 // SDA line 

	unsigned char data;

void InterruptHandlerHigh (void);

// High priority interrupt vector

#pragma code InterruptVectorHigh = 0x08 // comp mode default vector
void InterruptVectorHigh (void)
{
  _asm
    goto InterruptHandlerHigh //jump to interrupt routine
  _endasm
}

//----------------------------------------------------------------------------
// Low priority interrupt routine

#pragma code
#pragma interrupt InterruptHandlerHigh

void InterruptHandlerHigh ()
{
	if ( PIR1bits.SSPIF==1){
		if (SSPSTATbits.R == 1){    
		data = SSPBUF; // read data from master
		LATB=data;
		SSPCON1bits.CKP=1;   // Release SCL line
		}
	    else {             // send data to master
        data=SSPBUF  ;  
	//	PORTB=data;       
        }
	PIR1bits.SSPIF==0;
	}

}

void init(); 
void main(void){

init();// setup
//LATBbits.LATB4=1;
while(1){
unsigned char cont = 0x22;
data=SSPBUF;
if ( data==cont)
{
LATCbits.LATC0=1;
LATCbits.LATC1=1;
}
}
}

void init (){
ADCON1=0x07;//Configure A/D
TRISCbits.TRISC0=0;
TRISCbits.TRISC1=0;
LATCbits.LATC0=0;
LATCbits.LATC1=0;
//LATCbits.LATC0=1; // light up
SDA=1; // input
SCL=1;// input
// SDA & SCL as inputs 
//TRISB=0;
// SSPIE is located on the High vector of interrupts
// compability mode
//PIE1bits.SSPIE=1; // MSSP IE
//INTCON = 0b11000000; // GIE and PIE enable

// SSPMSK-> No mask
// 7-Bit Slave mode:
//bit 7-1 ADD<6:0>: 7-bit address
//bit 0 Not used: Unused in this mode. Bit state is a dont care.
SSPADD=0x22; // address
SSPSTAT=0b10000000; // Slew Rate control (SMP) 100kHz
// baud rate 100.000kHz
SSPCON1= 0b00110110; // I2C Slave mode, 7-bit address , SSPEN enable , release clock
}

